var led = require('@amperka/led').connect(P1); 

led.turnOff();

var marsohod = require('@amperka/robot-2wd').connect();
var receiver = require('@amperka/ir-receiver').connect(P3);

var lineFollower;

var	modeSelected=false;
var SPEED = 0.3;

 receiver.on('receive', function(code)
 {
  marsohod.stop();
   if (modeSelected===false)
   {
       //marsohod	
		SPEED = 0.5;
		 if (code === receiver.keys.TOP) 
		 {
		 	marsohod.go({l: SPEED, r: SPEED});
		 }
		 if (code === receiver.keys.BOTTOM) 
		 {
		 	marsohod.go({l: -SPEED, r: -SPEED});
		 }
		 if (code === receiver.keys.LEFT) 
		 {
		 	marsohod.go({l: 0, r: SPEED});
		 }
		 if (code === receiver.keys.RIGHT) 
		 {
		 	marsohod.go({l: SPEED, r: 0});
		 }
   
   } 
    if (code === receiver.keys.X&&modeSelected===false)
   {
      var FORWARD_SPEED = 0.3;
      var BACKWARD_SPEED = 0.8;
      var BORDER_VALUE = 0.2;
      var intervalID;

      var cleaner = require('@amperka/robot-2wd').connect();
      var lineSensor = require('@amperka/analog-line-sensor');
      var leftSensor = lineSensor.connect(A0);
      var rightSensor = lineSensor.connect(A1);
 
      function clean() {
        if (leftSensor.read() > BORDER_VALUE) {
          cleaner.go({l: 0, r: -BACKWARD_SPEED});
        } else if (rightSensor.read() > BORDER_VALUE) {
          cleaner.go({l: -BACKWARD_SPEED, r: 0});
        } else {
          cleaner.go({l: FORWARD_SPEED, r: FORWARD_SPEED});
        }
      }
 
    if (!intervalID) {
      leftSensor.calibrate({white: leftSensor.read()});
      rightSensor.calibrate({white: rightSensor.read()});
      intervalID = setInterval(clean, 10);
    } else {
      cleaner.stop();
      intervalID = clearInterval(intervalID);
    }
     modeSelected=true;
  }

	 if (code === receiver.keys.Y&&modeSelected===false)
     {
       //sledopyt
        modeSelected=true;
		SPEED = 0.25;
		var detective = require('@amperka/robot-2wd').connect();
		var lineSensor = require('@amperka/analog-line-sensor');
		var leftSensor = lineSensor.connect(A0);
		var rightSensor = lineSensor.connect(A1);
  
       leftSensor.calibrate({
                 black: 0.5,
                 white: leftSensor.read(),//vozmogno ubrat' ili postavit' 0.8
                 });
        rightSensor.calibrate({
                 black: 0.5,
                 white: rightSensor.read(),//vozmogno ubrat' ili postavit' 0.8
                 });
       
		var lineFollower = require('@amperka/pid').create({
		 target: 0,
		 kp: 6,//6,
		 ki: 0.1,// 0.1,
		 kd: -1,//-1,
		 outputMin: -SPEED,
		 outputMax: SPEED
		});
		lineFollower.run(function() {
		 var right = rightSensor.read();
		 var left = leftSensor.read();
		 var error = left - right;
		 var output = lineFollower.update(error) ;
		 detective.go({
		 l: SPEED + output ,
		 r: SPEED - output 
		 });
		}, 0.04);
     }

   if (code === receiver.keys.Z&&modeSelected===false)
   {
     		//prilipala
     //        ,        5V  VIN.
       modeSelected=true;
		SPEED = 0.5;
		var DISTANCE_MIN = 10;
		var DISTANCE_MAX = 14;
		var sticker = require('@amperka/robot-2wd')
		 .connect();
		var ultrasonic = require('@amperka/ultrasonic').connect({
		 trigPin: P12,
		 echoPin: P13
		});
		var check = function(distance) {
		if (distance > DISTANCE_MAX) {
		 sticker.go({l: SPEED, r: SPEED});
		 } else if (distance < DISTANCE_MIN) {
		 sticker.go({l: -SPEED, r: -SPEED});
		 } else {
		 sticker.stop();
		 }
		};
		var timerId = setInterval(function() {
		 ultrasonic.ping(function(error, value) {
		 if (!error) {
		 check(value);
		 }
		 }, 'cm');
		}, 100);
   }

   if (code === receiver.keys.POWER) 
 		reset();

 });

var gasSensor = require('@amperka/gas-sensor').connect({
  dataPin: A2, //  SVG
  heatPin: P11, //  GHE
  model: 'MQ3'
});
 
gasSensor.preheat(function() 
{
  var basePpm = gasSensor.calibrate();
  print('PPM base in current environment: ', basePpm);
   led.turnOn();
    setInterval(function() 
    {
	    var val = gasSensor.read('C2H5OH');
	    print('C2H5OH PPM =', val);
	    //vozmogno drugie znacheniya
	    if (val >= 0.05)
	    {
	    	led.blink(0.5, 0.5);
	    }
	    else
	    {
	    	led.turnOn();
	    }
  	}, 1000);

});


 


